Name:           perl-perfSONAR_PS-Services-Daemon
Version:        0.09
Release:        1%{?dist}
Summary:        perfSONAR_PS::Services::Daemon Perl module
License:        distributable, see LICENSE
Group:          Development/Libraries
URL:            http://search.cpan.org/dist/perfSONAR_PS-Services-Daemon/
Source0:        http://www.cpan.org/modules/by-module/perfSONAR_PS/perfSONAR_PS-Services-Daemon-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
Requires:       perl(Config::General) >= 2.3
Requires:       perl(HTTP::Daemon) >= 1.35
Requires:       perl(Log::Dispatch::FileRotate) >= 1
Requires:       perl(Log::Dispatch::Screen) >= 1
Requires:       perl(Log::Dispatch::Syslog) >= 1
Requires:       perl(Log::Log4perl) >= 1
Requires:       perl(Module::Load) >= 0.1
Requires:       perl(Params::Validate) >= 0.7
Requires:       perl(XML::LibXML) >= 1.58
Requires:       perl(perfSONAR_PS::Common) >= 0.09
Requires:       perl(perfSONAR_PS::Error) >= 0.09
Requires:       perl(perfSONAR_PS::Error_compat) >= 0.09
Requires:       perl(perfSONAR_PS::Messages) >= 0.09
Requires:       perl(perfSONAR_PS::XML::Document_string) >= 0.09
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description
The perfSONAR_PS::Services::Daemon is the main daemon that is used to start
the perfSONAR services. To use the daemon, install the modules for the
services one is interested in and configure the services in perfsonar.conf.

%prep
%setup -q -n perfSONAR_PS-Services-Daemon-%{version}

%build
# we need to edit the files before we install them
awk "{gsub(/^PIDDIR=.*/,\"PIDDIR=/var/run\"); gsub(/^BINDIR=.*/,\"BINDIR=/usr/bin\"); gsub(/^CONFDIR=.*/,\"CONFDIR=/etc\"); print}" perfsonar-daemon.init > perfsonar-daemon.new
mv perfsonar-daemon.new perfsonar-daemon.init

perl -i -p -e "s/was_installed = 0/was_installed = 1/" psConfigureDaemon
awk "{gsub(/XXX_CONFDIR_XXX/,\"/etc/perfsonar\"); print}" psConfigureDaemon > psConfigureDaemon.new
mv -f psConfigureDaemon.new psConfigureDaemon

perl -i -p -e "s/was_installed = 0/was_installed = 1/" perfsonar
awk "{gsub(/XXX_LIBDIR_XXX/,\"/usr/lib/perl\"); gsub(/XXX_CONFDIR_XXX/,\"/etc/perfsonar\"); print}" perfsonar > perfsonar.new
mv -f perfsonar.new perfsonar

%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

make pure_install PERL_INSTALL_ROOT=$RPM_BUILD_ROOT

find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} \;
find $RPM_BUILD_ROOT -type d -depth -exec rmdir {} 2>/dev/null \;

mkdir -p $RPM_BUILD_ROOT/etc/perfsonar
mkdir -p $RPM_BUILD_ROOT/etc/init.d

install -s -m 755 perfsonar-daemon.init $RPM_BUILD_ROOT/etc/init.d/perfsonar-daemon

install -m 755 logger.conf $RPM_BUILD_ROOT/etc/perfsonar

chmod -R u+rwX,go+rX,go-w $RPM_BUILD_ROOT/*

%check
make test

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%{_bindir}/*
%{_mandir}/man1/*
%{perl_vendorlib}/*
%{_mandir}/man3/*
/etc/init.d/*
/etc/perfsonar/*
/etc/perfsonar

%changelog
* Thu Mar 27 2008 aaron@internet2.edu 0.09-1
- Specfile autogenerated.
